#IfNDef _OGSSTD_

#Define _OGSSTD_

#IfDef   NotUltime

#command Assert([<_exp>][,[<_msg>]])                               ;
      => If(!(<_exp>))                                             ;
       ;    Alert("ProcName: "+ProcName(0)+";"                     ;
                 +"ProcLine: "+LTrim(STR(ProcLine()))+";;"         ;
                 +"Assertion failed: "+If(<._msg.>,<_msg>,<"_exp">);
                 ,{"Break"})                                       ;
       ;    AltD()                                                 ;
       ;    Quit                                                   ;
       ; End

#Else    // IfDef NotUltime

#Command ASSERT([<_exp>][,[<_msg>]]) =>

#EndIf   // IfDef NotUltime

//!Text+ OGSSTD.CH      Boolean constants and operators

// ͻ
//  Nicer then using '.'s                                                   
// ͼ
#xTranslate OR        => .OR.                               // These are nicer
#xTranslate AND       => .AND.                              //  , , , , , , ,
#xTranslate NOT       => .NOT.                              //  , , , , , , ,
#xTranslate TRUE      => .T.                                //  , , , , , , ,
#xTranslate FALSE     => .F.                                //  , , , , , , ,

//!Text-

//!Text+ OGSSTD.CH      Test for 'ValType(x)'

// ͻ
//  Test for 'ValType(x)' and NIL-values                                    
// ͼ
#xTranslate IsA(<_x>)  => ValType(<_x>)=="A"
#xTranslate IsB(<_x>)  => ValType(<_x>)=="B"
#xTranslate IsC(<_x>)  => ValType(<_x>)=="C"
#xTranslate IsD(<_x>)  => ValType(<_x>)=="D"
#xTranslate IsL(<_x>)  => ValType(<_x>)=="L"
#xTranslate IsM(<_x>)  => ValType(<_x>)=="M"
#xTranslate IsN(<_x>)  => ValType(<_x>)=="N"
#xTranslate IsO(<_x>)  => ValType(<_x>)=="O"
#xTranslate IsU(<_x>)  => ValType(<_x>)=="U"

#xTranslate NotA(<_x>) => !(ValType(<_x>)=="A")
#xTranslate NotB(<_x>) => !(ValType(<_x>)=="B")
#xTranslate NotC(<_x>) => !(ValType(<_x>)=="C")
#xTranslate NotD(<_x>) => !(ValType(<_x>)=="D")
#xTranslate NotL(<_x>) => !(ValType(<_x>)=="L")
#xTranslate NotM(<_x>) => !(ValType(<_x>)=="M")
#xTranslate NotN(<_x>) => !(ValType(<_x>)=="N")
#xTranslate NotO(<_x>) => !(ValType(<_x>)=="O")
#xTranslate NotU(<_x>) => !(ValType(<_x>)=="U")

//!Text-


//!Text+ OGSSTD.CH      NIL-items

// ͻ
//  NIL-items                                                               
// ͼ
#Define     A_NIL {}
#Define     B_NIL {||NIL}
#Define     C_NIL ""
#Define     D_NIL CToD("01/01/00")
#Define     L_NIL .F.
#Define     M_NIL ""
#Define     N_NIL 0
#Define     O_NIL OGS_NILobject():New()
#Define     X_NIL NIL

//!Text-

//!Text+ OGSSTD.CH      Boxes

// ͻ
//  Boxes                                                                   
// ͼ
#define B_SINGLE        "Ŀ "
#define B_DOUBLE        "ͻȺ "
#define B_SINGLE_DOUBLE "ķӺ "
#define B_DOUBLE_SINGLE "͸Գ "
#define B_SOLID         " "
#define B_FILLSOLID     ""

//!Text-

//!Text+ OGSSTD.CH      Beep's

// ͻ
//  Beep's                                                                  
// ͼ
#Define BEEP_KEY              1 // Keyboard error ( Wrong key pressed )
#Define BEEP_MOUSE            2 // Clicked with mouse in wrong area
#Define BEEP_MSG              3 // A message is ready for reading
#Define BEEP_BUMP             4 // Bumped into end/top/left/right of something
#Define BEEP_UNKNOWN          5 // For internal use only
#Define BEEP_ERROR            6 // Beep used for error-messages
#Define BEEP_TYPEOUT          7 // If charracter dous not fit the field
#Define BEEP_WARNING          8 // Beep used for warning-messages
#Define BEEP_SILENT           9 // Make no sound ( Be silent )
#Define BEEP_NOT_ENA         10 // Option disabled ( User selectable option )

//!Text-

//!Text+ OGSSTD.CH      Handles

// ͻ
//  Handles                                                                 
// ͼ
#Define HANDLE_CON_INP 0 // Console input
#Define HANDLE_CON_OUT 1 // Console output
#Define HANDLE_CON_DEV 1 //  , , , , , , ,
#Define HANDLE_ERR_OUT 2 // Error output
#Define HANDLE_AUX_OUT 3 // Auxiliary output
#Define HANDLE_PRN_OUT 4 // Printer output
#Define HANDLE_PRN_DEV 4 //  , , , , , , ,

//!Text-

//!Text+ OGSSTD.CH      Functions written in C or ASM

// ͻ
//  Functions written in C or ASM                                           
// ͼ
#xTranslate IsProtMode([<_x,...>]);       // TRUE if running in protected mode
         => J_ISPROTMODE()

#xTranslate ConNumb([<_x,...>]);  // Novell connection number or '00' if MsDos
         => J_CONNUMB()

#xTranslate Week([<_x,...>]);                  // Compute weeknumber 1..52(53)
         => J_WEEK(<_x>)

#xTranslate TrueName([<_x,...>]);            // Get the 'TrueName' of the file
         => J_TRUENAME(AllTrim(<_x>))

#xTranslate IsNovell([<_x,...>]);         // Return TRUE if 'Novell' is active
         => J_ISNOVELL()

#xTranslate Roloc([<_x,...>]);                                // Reverse color
         => J_ROLOC(<_x>)

#xTranslate CurDrive([<_x,...>]);                         // Get current drive
         => J_CURDRIVE()

#xTranslate AttrToA([<_x,...>]);              // Translate attr to colorstring
         => J_ATTR2NOR(<_x>)

#xTranslate AttrRevToA([<_x,...>]);   // Translate attr to reverse colorstring
         => J_ATTR2REV(<_x>)

//!Text-

//!Text+ OGSSTD.CH      Object(Class(y)) related

// ͻ
//  Object(Class(y)) related                                                
// ͼ
#xTranslate ColumnNew([<_x,...>]);
         => OGS_Column(<_x>) // OGS_Column:New(<_x>)

#xTranslate DbfNew([<_x,...>]);
         => OGS_DbfSys():New(<_x>)

#xTranslate Ex5New([<_x,...>]);
         => OGS_Ex5Sys():New(<_x>)

#xTranslate ArrNew([<_x,...>]);
         => OGS_ArrSys():New(<_x>)

#xTranslate IniNew([<_x,...>]);
         => OGS_IniNew([<_x>])

#xTranslate IniGet([<_x,...>]);
         => OGS_IniSys():Get(<_x>)

#xTranslate ListNew([<_l>,<_i>[,<_a,...>]]);
         => OGS_List():New(<_l>,<_i>,<_a>)

#xTranslate StackNew([<_x,...>]);
         => OGS_StkSys():New()

#xTranslate KeyFnNew([<_x,...>]);
         => OGS_KeyFns():New(<_x>)

#xTranslate KeyboardGet();
         => OGS_KeySys():Keyboard

#xTranslate PermNew([<_p1>][,[<_p2>][,[<_p3>][,[<_p4>][,[<_x,...>]]]]]);
         => OGS_PrmSys():New(<_p1>,<_p2>,<_p3>,<_p4>,CompModule)

#xTranslate BrowseNew(<_o>,<_x1>,<_y1>,<_x2>,<_y2>[,[<_p6>][,[<_p7>][,[<_x,...>]]]]);
         => OGS_IBrowse():New(<_o>,<_x1>,<_y1>,<_x2>,<_y2>,<_p6>,<_p7>,CompModule)

#xTranslate BrowseNew(<_x1>,<_y1>,<_x2>,<_y2>);
         => OGS_TBrowse():New(<_x1>,<_y1>,<_x2>,<_y2>)

#xTranslate WinBorder([<_x,...>]);
         => OGS_WinSys():DefBorder(<_x>)

#xTranslate WinColors([<_x,...>]);
         => OGS_WinSys():DefColors(<_x>)

#xTranslate WinMark([<_x,...>]);
         => OGS_WinSys():Mark()

#xTranslate WinNew([<_x1>][,[<_y1>][,[<_x2>][,[<_y2>][,[<_p5>][,[<_p6>][,[<_p7>][,[<_p8>][,[<_p9>][,[<_x,...>]]]]]]]]]]);
         => OGS_WinSys():New(<_x1>,<_y1>,<_x2>,<_y2>,<_p5>,<_p6>,<_p7>,<_p8>,<_p9>,CompModule)

#xTranslate WinRelease([<_x,...>]);
         => OGS_WinSys():Release(<_x>)

#xTranslate WinTop([<_x,...>]);
         => OGS_WinSys():ScreenRoot:Last(TRUE)

#xTranslate PaddleNew([<_x,...>]);
         => OGS_Paddle():New(<_x>)

#xTranslate MillNew([<_x,...>]);
         => SEO_Mill():New(<_x>)

#xTranslate ColorNew([<_x,...>]);
         => SEO_Colr():New(<_x>)

#xTranslate PagePrintNew([<_x,...>]);
         => OGS_PPrnSys():New(<_x>)

#xTranslate LinePrintNew([<_x,...>]);
         => OGS_LPrnSys():New(<_x>)

#xTranslate DrvCreateNew([<_x,...>]);
         => PEDrvCreate():New(<_x>)

#xTranslate NENew([<_x,...>]);
         => NE():New(<_x>)

#xTranslate NotePadNew([<_x,...>]);
         => OGS_NotePad():New(<_x>)

#xTranslate IconNew([<_x,...>]);
         => OGS_Icon():New(<_x>)

#xTranslate TextEditNew([<_x,...>]);
         => OGS_TextEdit():New(<_x>)

#xTranslate BitMapNew([<_x,...>]);
         => OGS_BitMap():New(<_x>)

//!Text-

//!Text+ OGSSTD.CH      General purpose

// ͻ
//  General purpose                                                         
// ͼ
#Define     CRLF            Chr(13)+Chr(10)                        // New line
#Define     CrLf            Chr(13)+Chr(10)                        // New line
#Define     FF              Chr(13)+Chr(12)                        // FormFeed
#Define     CR              Chr(13)                                  // Return
#Define     LF              Chr(10)                                // LineFeed

#xCommand   Default <_a> To <_b>[,<_c> To <_d>][,<_e> To <_f>][,<_g> To <_h>];
         => If <_a>\==NIL;<_a>:=<_b>;End [;If <_c>\==NIL;<_c>:=<_d>;End];
          [;If <_e>\==NIL;<_e>:=<_f>;End][;If <_g>\==NIL;<_g>:=<_h>;End]

#xTranslate IfNil(<_a>,<_b>);                  // Another aproach to 'Default'
         => If(<_a>\==NIL,<_b>,<_a>)

#xTranslate SOut([<_Str>]);                          // String to standard out
         => OutStd(Chr(13)+Chr(10)[+<_Str>])

#xTranslate EOut([<_Str>]);                        // String to standard error
         => OutErr(Chr(13)+Chr(10)[+<_Str>])

#xTranslate If <_L> Then <_C1> [<_C2>] [Else <_C3> [<_C4>]]; // One-line I-T-E
         => If <_L>; <_C1> <_C2>;[ Else; <_C3> <_C4>;] End

#xTranslate WhileEnd <_e>;
         => While <_e>; End

#xTranslate DataBaseExt();     // Until a real extention-function is available
         => ".DBF"

#xTranslate Str2Block(<_str>);      // Create a codeblock from an macro-string
         => If(Empty(<_str>),{||NIL},&("{||"+<_str>+"}"))

#xTranslate Dow([<_d,...>]);                   // Return 0==Maandag..6==Zondag
         => (<_d>-CToD("01/01/1900"))%7

#xCommand   Repeat;              // Use 'Repeat; Programlines; Until Condition
         => While TRUE

#xCommand   Until <_lCondition>; // Use 'Repeat; Programlines; Until Condition
         => If <_lCondition>; Exit; End; End

#xCommand   ForceError;
         => Eval(ErrorBlock(),ErrorNew())

#xTranslate ForceError([<_x,...>]);
         => Eval(ErrorBlock(),MakeErrorNew(CompModule,<_x>))

#xCommand   Registrate [<_x,...>];
         => Init Procedure _ComlRegistrate();
          ;    ComlRegistrate(CompModule,CompDate,CompUltime);
          ; Return

#xTranslate Registrate([<_x,...>]);
         => ComlRegistrate(CompModule,CompDate,CompUltime)

#xTranslate KeyRead();
         => KeyRead(NIL,TRUE)

#xTranslate KeyRead(<_x>);
         => KeyRead(<_x>,TRUE)

//!Text-

//!Text+ OGSSTD.CH      Semaphore functions

// ͻ
//  Semaphore functions, All functions return NIL if an error occures       
// ͼ
#xTranslate SemOpen([<_s>][,<_v,...>]);                      // RetVal:=Handle
         => J_SEMOPEN(AllTrim(<_s>)[,<_v>])

#xTranslate SemValue([<_h,...>]);                           // RetVal:=Numeric
         => J_SEMVALUE(<_h>)

#xTranslate SemCount([<_h,...>]);                           // RetVal:=Numeric
         => J_SEMCOUNT(<_h>)

#xTranslate SemWait([<_h>][,<_t,...>]);                     // RetVal:=Logical
         => J_SEMWAIT(<_h>[,<_t>])

#xTranslate SemSignal([<_h,...>]);                          // RetVal:=Logical
         => J_SEMSIGNAL(<_h>)

#xTranslate SemClose([<_h,...>]);                           // RetVal:=Logical
         => J_SEMCLOSE(<_h>)

//!Text-

//!Text+ OGSSTD.CH      Replace clipper functions

// ͻ
//  Replace clipper functions                                               
// ͼ
#xTranslate KeyboardInKey();
         => OGS_KeySys():Keyboard:KeyRead(NIL,TRUE)

#xTranslate KeyboardInKey(<_x>);
         => OGS_KeySys():Keyboard:KeyRead(<_x>,TRUE)

#xTranslate KeyboardInKey(<_x>,<_y,...>);
         => OGS_KeySys():Keyboard:KeyRead(<_x>,<_y>)

#xTranslate KeyboardNext([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyNext

#xTranslate KeyboardClear([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyClear()

#xTranslate KeyboardReset([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyReset()

#xTranslate KeyboardLast([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyLast

#xTranslate KeyboardStuff([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyStuff(<_x>)

#xTranslate LastKey([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyLast

#xCommand   Keyboard <_x>;
         => OGS_KeySys():Keyboard:KeyStuff(<_x>)

#xTranslate NextKey([<_x,...>]);
         => OGS_KeySys():Keyboard:KeyNext

#xTranslate Beep();
         => Beeper(BEEP_KEY)

#IfNDef     DO_NOT_XLAT_CLIPPER

#xTranslate InKey();
         => OGS_KeySys():Keyboard:KeyRead(NIL,TRUE)

#xTranslate InKey(<_x>);
         => OGS_KeySys():Keyboard:KeyRead(<_x>,TRUE)

#xTranslate InKey(<_x>,<_y,...>);
         => OGS_KeySys():Keyboard:KeyRead(<_x>,<_y>)

#xTranslate SetCursor([<_Crs>][,<_x,...>]);
         => CursorSwitch(If(IsL(<_Crs>),<_Crs>,0!=<_Crs>))

#xTranslate SetColor([<_x,...>]);
         => ColorClip(<_x>)

#EndIf   // DO_NOT_XLAT_CLIPPER

//!Text-

//!Text+ OGSSTD.CH      ComlMain

// ͻ
//  Replace Procedure|Function 'Main(P0..Pn)' with 'Main ...' to have full  
//  access to parameters supplied from the DOS-commandline.                 
// Ķ
//  Note: For more information see 'OCOMLIN'-function documentation         
// ͼ
#xCommand   Main [CREDITS <_CRights>] [MIN <_MinPrms>] [MAX <_MaxPrms>]      ;
                 [OPTIONS <_Opts>] [INFO <_PrgInfo>] [SAVESCREEN <_ScrnFlg>] ;
         => Procedure Main()                                                 ;
          ; Local ComlOptsArr:=(GsdGpInstall(),AltD(),ComlGetIt(<_CRights>   ;
                               ,<_MinPrms>,<_MaxPrms>,<_Opts>,CopyRightsOwner;
                               ,<_PrgInfo>,<_ScrnFlg>,CompUltime,CompDate))

#xCommand   EndMain;
         => ComlRestScrn(); Return

#xCommand   EndMain <RetVal>;
         => ComlRestScrn(); ErrorLevel(<RetVal>); Return

//!Text-

#EndIf
